#!/bin/bash

####################################################################################################
#
# WARNING: DO NOT EDIT THIS FILE BY HAND AS IT WILL BE OVERWRITTEN BY SKELETOR WHEN YOU RUN UPDATE
#
####################################################################################################

PROJECT_DIR="$(realpath "$(dirname "$0")/..")"
PROJECT_NAME="$(basename "$PROJECT_DIR")"

main_branch_name() {
	if git rev-parse --quiet --verify main >/dev/null 2>&1; then
		echo main
	else
		echo master
	fi
}

upstream_remote_exists() {
	git ls-remote --exit-code upstream >/dev/null 2>&1
}

if [ -n "$(git status --porcelain)" ]; then
	echo "Working copy is not clean. Refusing to continue"
	exit 1
fi

if [ "$(git br --show-current)" != "$(main_branch_name)" ]; then
	echo "Not in $(main_branch_name) branch. Refusing to continue"
	exit 1
fi

echo Latest 4 tags are:
echo
git tag --sort=-committerdate | head -4
echo
echo -n "Enter desired new version: "
read -r VERSION

echo New version will be: "${VERSION}"
echo -n "Confirm (y/N)? "
read -r CONFIRM

if [ "$CONFIRM" != "y" ]; then
	exit 1
fi

echo ==== Patching package manager files...
sed -i "s/^pkgver=.*/pkgver=$VERSION/" arch/PKGBUILD
git add arch/PKGBUILD

sed -i "s/^Version:.*/Version:          $VERSION/" "fedora/${PROJECT_NAME}.spec"
git add "fedora/${PROJECT_NAME}.spec"

git commit -m "chore: prepare version $VERSION"

echo ==== Tagging...
git tag "$VERSION"

echo ==== Pushing...
git push origin
git push origin --tags
upstream_remote_exists && git push upstream
upstream_remote_exists && git push upstream --tags
